/*
 * Created on Jun 16, 2005
 *
 * Copyright  2005 Sun Microsystems, Inc., 4150 Network Circle, Santa Clara, California 95054, U.S.A. All rights reserved.

Sun Microsystems, Inc. has intellectual property rights relating to technology embodied in the product that is described in this document. In particular, and without limitation, these intellectual property rights may include one or more of the U.S. patents listed at http://www.sun.com/patents and one or more additional patents or pending patent applications in the U.S. and in other countries.

U.S. Government Rights - Commercial software. Government users are subject to the Sun Microsystems, Inc. standard license agreement and applicable provisions of the FAR and its supplements.

Use is subject to license terms.

Sun, Sun Microsystems and the Sun logo are trademarks or registered trademarks of Sun Microsystems, Inc. in the U.S. and other countries.

This product is covered and controlled by U.S. Export Control laws and may be subject to the export or import laws in other countries. Nuclear, missile, chemical biological weapons or nuclear maritime end uses or end users, whether direct or indirect, are strictly prohibited. Export or reexport to countries subject to U.S. embargo or to entities identified on U.S. export exclusion lists, including, but not limited to, the denied persons and specially designated nationals lists is strictly prohibited. 
 *
 */
package com.sunlabs.archsim;

import java.util.List;

import com.sunlabs.archsim.engine.Director;
import com.sunlabs.archsim.runner.OperationLoader;
import com.sunlabs.archsim.runner.Runner;

/**
 * @author ib27688
 * 
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *
 * This is archsim executable. It executes a list of operations 
 * from a file.
 * 
 */
public class Simulator {

	public static final String SCRIPT_DEF= "script.xml"; 
	
	public static void main(String[] args) {
		
		Director director= Director.getInstance();
		
		String fileName;
		
		if (args.length == 1) {
			fileName= args[0];			
		}
		else {
			// use default script file
			fileName= SCRIPT_DEF;
		}
		OperationLoader ldr= new OperationLoader();
		List ops= ldr.load(fileName);
		
		Runner r= new Runner();
		r.perform(ops);
		
		director.closeJournal();		
	}
} // Simulator
