/*
 * Copyright 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */
package com.sunlabs.archsim.fleet.ships.constant;

import java.util.List;

import com.sunlabs.archsim.base.hierarchy.Entities;
import com.sunlabs.archsim.base.hierarchy.CompositeEntity;
import com.sunlabs.archsim.engine.Director;
import com.sunlabs.archsim.fleet.common.Data;
import com.sunlabs.archsim.fleet.ships.testing.DataSink;
import com.sunlabs.archsim.runner.OperationLoader;
import com.sunlabs.archsim.runner.Runner;

import junit.framework.TestCase;
import junit.textui.TestRunner;

public class ConstantTest extends TestCase {

	private Constant constantShip;
	
	// used for manula test invocation
	public static void main(String[] args) {
        // run the tests
        TestRunner.run(ConstantTest.class);			
	}
	
	public void setUp() {
		
	}
	
	public void tearDown() {
		Director.getInstance().masterClear();
	}
	
	// first do the self check
	public void testSelfCheck() {
		Object tst=Entities.find("ConstantTest");
		CompositeEntity testGroup= (CompositeEntity)tst;
		assert(testGroup.selfCheck());		
	}	
	
	// now test the operation of a BitBucket
	public void testConstantOperation() {
		OperationLoader ldr= new OperationLoader();
		List ops= ldr.load("src/" 
				+ ConstantTest.class.getPackage().getName().replace('.', '/') 
				+ "/ConstantTestScript.xml");
		
		Runner r= new Runner();
		r.perform(ops);
		
		// get the constantShip
		constantShip= (Constant)(Entities.find("Constant"));
		Data constantValue= constantShip.value();
                // get the DataSink SHIP 
                DataSink dataSink= (DataSink)Entities.find("DataSink");

                // compare received data with the constant value
		// all values must equal the constant value
		for (Data d: dataSink.receivedData) {
			assert(d.equals(constantValue));
		}
		
	} // operationTest	
	
} // ConstantTest
